function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import dayjs from "dayjs";
import { isUndefined } from "@pisell/utils";
import { getValueByKeys } from "../../utils";

/**
 * 判断给定的日期是否在指定的日期范围内
 * @param date 给定的日期
 * @param range 指定的日期范围，格式为 [开始日期, 结束日期]
 * @returns 如果给定的日期在指定的日期范围内，则返回 true，否则返回 false
 */
function isDateInRange(date, _ref) {
  var _ref2 = _slicedToArray(_ref, 2),
    startDate = _ref2[0],
    endDate = _ref2[1];
  return date.isSame(startDate) || date.isSame(endDate) || date.isAfter(startDate) && date.isBefore(endDate);
}

/**
 * 判断dataSource日期是否在filters范围内
 * @param value 日期数组
 * @param key 对应日期在对象中的键
 * @param item 包含日期的对象
 * @returns 如果日期在给定范围内返回true，否则返回false
 */
export default function (_ref3) {
  var value = _ref3.value,
    key = _ref3.key,
    item = _ref3.item;
  if (!value) return true;
  if ((value === null || value === void 0 ? void 0 : value.length) !== 2) return true;
  var valueDayjsObj = value.map(function (item) {
    return dayjs(item || "");
  });
  if (valueDayjsObj.some(function (item) {
    return !item.isValid();
  })) {
    return true;
  }
  var dataValue = getValueByKeys(item, key);
  if (isUndefined(dataValue)) return false;
  var dataDayjsObj = dayjs(dataValue);
  if (!dataDayjsObj.isValid()) return false;
  return isDateInRange(dataDayjsObj, valueDayjsObj);
}